import akka.{ NotUsed, Done }
import akka.actor._
import akka.stream._
import akka.stream.scaladsl._

import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent.Future

object Example extends App {
  implicit val system = ActorSystem()
  implicit val materializer = ActorMaterializer()

  val source: Source[Int, NotUsed] = Source(Stream.continually(5))

  val double: Flow[Int, Int, NotUsed] = Flow[Int].map(_ * 2)

  val sink: Sink[Int, Future[Done]] = Sink.foreach { x =>
    Thread.sleep(1000)
    println(x)
  }

  class PrintActor extends Actor {
    def receive = {
      case msg: String => println(msg)
    }
  }

  val messageSource = Source(collection.immutable.Iterable("Hallo","huhu","Wie gehts?"))
  val actorSink = Sink.actorRef[String](system.actorOf(Props[PrintActor]),"Done")


  messageSource.to(actorSink).run()

  readLine()
  system.terminate()

}